<template>
	<div :id="id">
		<div :class="$style.videos">
			<div v-for="(video, index) in videos" :key="index" :class="$style.videoContainer">
				<div
					:class="$style.videoContainerInner"
					:style="{ paddingBottom: paddings.desktop, '--padding-bottom-mobile': paddings.mobile }"
				>
					<div
						v-if="video.videoLabel"
						:class="$style.videoLabelLayer"
						:style="{ color: video.videoLabelColor || 'white' }"
					>
						<h3 :class="$style.videoLabelText">{{ video.videoLabel }}</h3>
					</div>

					<ProviderElementActivityTracker v-slot="{ isFocused }">
						<MoleculeAutoplayVideoPlayPause :class="$style.videoPlayerWrapper" :show-button="isFocused">
							<video
								v-if="video.video && video.video.url"
								v-lazy.video="videoUrl(video.video.url)"
								:class="$style.videoPlayer"
								autoplay
								muted
								loop
								playsinline
							/>
						</MoleculeAutoplayVideoPlayPause>
					</ProviderElementActivityTracker>
				</div>
			</div>
		</div>
		<div v-if="hasDescription || hasButton" :class="$style.bottom">
			<div :class="$style.bottomInner">
				<div v-if="hasDescription" v-rich-content :class="$style.text" v-html="description"></div>
				<div v-if="hasButton" :class="$style.buttonWrapper">
					<BaseButtonArrow :smart="ctaLink.url" :target="ctaLink.target" size="medium" force-color>{{
						ctaText || ctaLink.url
					}}</BaseButtonArrow>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import ProviderElementActivityTracker from '@components/provider-element-activity-tracker';
import MoleculeAutoplayVideoPlayPause from '@components/molecule-autoplay-video-play-pause';

export default {
	components: { ProviderElementActivityTracker, MoleculeAutoplayVideoPlayPause },

	props: {
		id: {
			type: String,
			default: null,
		},

		videos: {
			type: Array,
			default: () => [],
		},

		mobileAspectRatio: {
			type: Number,
			default: 1,
		},

		desktopAspectRatio: {
			type: Number,
			default: 1,
		},

		description: {
			type: String,
			default: '',
		},

		ctaText: {
			type: String,
			default: '',
		},

		ctaLink: {
			type: Object,
			default: null,
		},
	},

	computed: {
		paddings() {
			return {
				mobile: `${(1 / (this.mobileAspectRatio || 1)) * 100}%`,
				desktop: `${(1 / (this.desktopAspectRatio || 1)) * 100}%`,
			};
		},

		hasDescription() {
			const { description } = this;
			return !(!description || description.length === 0 || description === '<p></p>');
		},

		hasButton() {
			const { ctaLink } = this;
			return ctaLink && ctaLink.url;
		},
	},

	methods: {
		videoUrl(url) {
			const videoUrl = decodeURIComponent(url);
			if (videoUrl.startsWith('https://molekule.cdn.prismic.io/')) {
				const videoFile = videoUrl.split('/');
				return '/prismic-images/molekule/' + videoFile[videoFile.length - 1];
			}
			return url;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.videos {
	display: flex;
	flex-wrap: wrap;
}

.videoContainer {
	flex: 0 0 auto;
	width: 100%;

	@include above('medium') {
		width: 50%;
	}
}

.videoContainerInner {
	position: relative;
	overflow: hidden;

	@include below('medium') {
		padding-bottom: var(--padding-bottom-mobile) !important;
	}
}

.videoLabelLayer {
	position: absolute;
	top: 0;
	left: 0;
	display: flex;
	align-items: center;
	justify-content: center;
	width: 100%;
	height: 100%;
	padding: size('s');
	text-align: center;
}

.videoLabelText {
	z-index: 1;
	white-space: pre-line;

	@include font-family('secondary');
	@include use-text-style('heading-650');

	@include above('xlarge') {
		@include use-text-style('heading-900');
	}
}

.videoPlayerWrapper {
	position: absolute;
	top: 50%;
	left: 50%;
	width: auto;
	min-width: 100%;
	max-width: none;
	height: 100%;
	min-height: 100%;
	transform: translate(-50%, -50%);
}

.videoPlayer {
	width: 100%;
	height: 100%;
	object-fit: cover;
}

.bottom {
	padding: size('l') (size('s') * 2);
	text-align: center;
	background-color: color('primary-600');

	@include above('xlarge') {
		padding-top: size('xxl');
		padding-bottom: size('xxl');
	}
}

.buttonWrapper {
	&:nth-child(2) {
		margin-top: size('m');

		@include above('xlarge') {
			margin-top: size('l');
		}
	}
}

.bottomInner {
	max-width: 87rem;
	margin: 0 auto;
}

.text {
	@include use-text-style('heading-100');

	font-weight: 300;

	p {
		&:not(:last-child) {
			margin-bottom: 1em;
		}
	}

	a {
		text-decoration: underline;
	}
}
</style>
